<?php

if ( !defined('IN_PHPBB') )
{
	die('Hacking attempt');
	exit;
} 
// Do we have an id? No, then just exit
if (empty($HTTP_GET_VARS['id']))
{
	exit;
} 

$confirm_id = htmlspecialchars($HTTP_GET_VARS['id']);

if (!preg_match('/^[A-Za-z0-9]+$/', $confirm_id))
{
	$confirm_id = '';
}
/**
  * Check if GD exisits, otherwise we will use the default phpbb confirm page ;)
  **/
$gd = true;
if(!extension_loaded("gd")){
	//Gd isn't loaded
	//Display error messages always, or not?
	$gd = false;
}
if(!function_exists("gd_info") || !function_exists('imagettftext')){
	//GD function, gd_info don't exists. GD isn't loaded correctly.
	//Freetype function imagettftext doesn't exists. This is required by this mod.
	$gd = false;
}    
if($gd === false){
 	//GD not loaded, or one of the needed functions aren't there. Require usercp_confirm ;)
 	require($phpbb_root_path . 'includes/usercp_confirm.' . $phpEx);
 	die;
}

// Try and grab code for this id and session
$sql = 'SELECT code  
	FROM ' . CONFIRM_TABLE . " 
	WHERE session_id = '" . $userdata['session_id'] . "' 
		AND confirm_id = '$confirm_id'";
$result = $db->sql_query($sql);

// If we have a row then grab data else create a new id
if ($row = $db->sql_fetchrow($result))
{
	$db->sql_freeresult($result);
	$code = $row['code'];
}
else
{
	exit;
}  

$len = strlen($code);
$im = ImageCreate(24 * $len, 24);
$background = ImageColorAllocate($im, 255, 255, 255);

$bg_file = $phpbb_root_path . 'includes/chinese_img/background.gif';
$im_bg = @ImageCreateFromGIF($bg_file);
if ($im_bg) {
    list($width, $height, $type, $attr) = @GetImageSize($bg_file); 
    if (function_exists('ImageCopyReSampled'))
        ImageCopyReSampled($im, $im_bg, 0, 0, 0, 0, 24 * $len, 24, $width, $height);
    else
        ImageCopyReSized($im, $im_bg, 0, 0, 0, 0, 24 * $len, 24, $width, $height);
    ImageDestroy($im_bg);
}

for ($i = 0; $i < $len; $i++) {
    $im_num = @ImageCreateFromPNG($phpbb_root_path . 'includes/chinese_img/'.$code[$i].'.png');
    if ($im_num) {
        ImageColorTransparent($im_num, ImageColorAt($im_num, 0, 0));
        ImageCopy($im, $im_num, 24 * $i, 0, 0, 0, 24, 24);
        ImageDestroy($im_num);
    }
}

header("content-type:image/png");
header('Cache-control: no-cache, no-store');

ImagePNG($im);
ImageDestroy($im);
die;

?>
